/*
*
*       control
*         0  0    C = A
*         0  1    C = B
*         1  0    C = A + B
*         1  1    C = A - B
*/

module ALU(A,B,C,control);
input [15:0] A, B;
output [15:0] C;
input [1:0] control;

wire subtract, mux1, mux2;
assign {mux2, mux1} = control;
assign subtract = mux1;

wire [15:0] D,sum;

assign D = (subtract? ~B: B);
assign sum = A + D + subtract;
assign C = (mux2? sum: (mux1? B: A) );

endmodule